<script setup lang="ts">
  import { Product } from '@shopware-pwa/types';

  const props = withDefaults(
    defineProps<{
      data: Product;
      isAdded?: boolean;
      showBookmarkShortcut: boolean;
    }>(),
    { isAdded: false },
  );

  const emits = defineEmits<{
    (e: 'add'): void;
    (e: 'remove'): void;
  }>();

  const productId = computed(() => props.data.id);
  const product = computed(() => props.data);
  const { isBookmarked, toggleBookmark, loading: loadingBookmark } = useBookmarkItem(productId);
  const { addToCart, loading: loadingAddToCart, countAll } = useAddToCart(product);
  const { isLiked, like, unlike, loading: loadingLike } = useLikeItem(productId);
  const { controlledClient, permissionGranted } = useParticipants();
  const { quickViewModalController } = useQuickView();

  const handleQuickView = () => {
    quickViewModalController.open(props.data.id);
  };

  const handleLike = async () => {
    if (!product.value.extensions.attendeeProductCollections) {
      product.value.extensions.attendeeProductCollections = {};
    }

    if (!product.value.extensions.attendeeProductCollections?.likes) {
      product.value.extensions.attendeeProductCollections.likes = 0;
    }

    const currentLikes = Number(product.value.extensions.attendeeProductCollections.likes);
    if (isLiked.value) {
      await unlike();
      if (currentLikes >= 1) {
        product.value.extensions.attendeeProductCollections.likes = currentLikes - 1;
      }
    } else {
      await like();
      product.value.extensions.attendeeProductCollections.likes = currentLikes + 1;
    }
  };

  const isMainProduct = computed(() => {
    return !!(
      product.value.parentId === null &&
      product.value.childCount &&
      product.value.childCount > 0
    );
  });
</script>
<template>
  <SwProductCard
    :data="data"
    :show-percent-saved="false"
    :show-regulation-price="false"
    :is-main-product="isMainProduct"
    @click="handleQuickView"
  >
    <template #product-interact>
      <div class="flex gap-1.5">
        <SwBookmarkButton
          v-if="showBookmarkShortcut"
          variant="action"
          class="!px-2"
          :is-bookmarked="isBookmarked"
          :loading="loadingBookmark"
          @click="toggleBookmark"
        />
        <SwTooltip
          :disabled="isMainProduct || !controlledClient || permissionGranted"
          :content="$t('permissionToolTip')"
          position="topCenter"
          width="max-width"
        >
          <SwButton
            variant="action"
            class="border-transparent bg-gray-50 !px-2 shadow-none"
            :disabled="isMainProduct || !controlledClient || !permissionGranted"
            :loading="loadingAddToCart"
            @click="addToCart()"
          >
            <template #icon>
              <span class="i-sw-solid:shopping-cart text-sm" />
            </template>
            <template #default>
              {{ countAll }}
            </template>
          </SwButton>
        </SwTooltip>
        <SwButton
          variant="action"
          class="border-transparent bg-gray-50 !px-2 shadow-none"
          :disabled="!controlledClient"
          :loading="loadingLike"
          @click="handleLike"
        >
          <template #icon>
            <span :class="['i-sw-solid:heart text-sm', { 'text-crimson-500': isLiked }]" />
          </template>
          <template #default>
            {{ (product?.extensions as any)?.attendeeProductCollections?.likes ?? 0 }}
          </template>
        </SwButton>
      </div>
    </template>
    <template #product-action>
      <slot
        name="select-button"
        v-bind="{ isAdded, productId, add: () => emits('add'), remove: () => emits('remove') }"
      >
        <SwButton
          :variant="isAdded ? 'action' : 'primary'"
          @click="isAdded ? emits('remove') : emits('add')"
        >
          {{ isAdded ? $t('remove') : $t('add') }}
        </SwButton>
      </slot>
    </template>
  </SwProductCard>
</template>
